#include <fstream>
#include <iostream>

using namespace std;

typedef struct {
  unsigned int src_ip;
  unsigned int dst_ip;
  unsigned int bytes;
} record_t;

void printip(unsigned int ip)
{
	printf("%d.%d.%d.%d",(ip>>24)&0xff,(ip>>16)&0xff,(ip>>8)&0xff,ip&0xff);
}
void gen_binary(char* ofilename)
{
  char buffer[1024];
  char arg1[32],arg2[32],arg3[32],arg4[32],arg5[32],arg6[32];
  char ip1[4],ip2[4],ip3[4],ip4[4];
  fstream f;
  ofstream of;
  record_t r;

  // open the ofilename
  of.open(ofilename,ios::out | ios::binary);
  if(!of)
    {
      cerr << "Error opening the file " << ofilename << endl;
    }
  //if have head line add this
  //cin.getline(buffer,1024);
  //fprintf(stderr,"%s\n",buffer);
  string sep=" ";
  while(cin.getline(buffer,1024)) {
    sscanf(buffer,"%s %s %s %s %s %s",arg1,arg2,arg3,arg4,arg5,arg6);
    sscanf(arg1,"%[^.].%[^.].%[^.].%[^.]",ip1,ip2,ip3,ip4);
    r.src_ip=
      (atoi(ip1) << 24) + 
      (atoi(ip2) << 16) + 
      (atoi(ip3) << 8) + 
      (atoi(ip4));

    sscanf(arg2,"%[^.].%[^.].%[^.].%[^.]",ip1,ip2,ip3,ip4);
    r.dst_ip=
      (atoi(ip1) << 24) + 
      (atoi(ip2) << 16) + 
      (atoi(ip3) << 8) + 
      (atoi(ip4));
    r.bytes = atoi(arg4);
    // arg1 is the source ip address
    // arg2 is the destination ip address
    // arg4 is the packet size
    /*printf("DEBUG: SRC:");
    printip(r.src_ip);
    printf(" DEST:");
    printip(r.dst_ip);
    printf("      Value=%u\n",r.bytes);
    */
    of.write((char*)&r, sizeof(record_t));
  }
  of.close();
}

int main(int argc, char **argv)
{
  if (argc != 2) 
    {
      cerr << "Usage: gen_binary <outfile> <inputfile" << endl;
      exit(-1);
    }

  gen_binary(argv[1]);
  return(0);
}
